diff --git a/src/iflist.c b/src/iflist.c
index d2ba63100..62dc4e05f 100644
--- a/src/iflist.c
+++ b/src/iflist.c
@@ -418,16 +418,6 @@ ni_netconfig_rules_drop_by_seq(ni_netconfig_t *nc, unsigned int seq)
 	}
 }
 
-static inline void
-__ni_refresh_bonding_master_bind(ni_netdev_t *master, ni_linkinfo_t *link, const char *ifname)
-{
-	const ni_netdev_ref_t ref = { .name = (char *)ifname, .index = link->ifindex };
-	ni_bonding_slave_t *slave;
-
-	slave = ni_bonding_bind_slave(master->bonding, &ref, master->name);
-	ni_bonding_slave_set_info(slave, link->slave.bond);
-}
-
 static void
 __ni_refresh_bind_master(ni_netconfig_t *nc, ni_netdev_t *dev)
 {
@@ -439,19 +429,6 @@ __ni_refresh_bind_master(ni_netconfig_t *nc, ni_netdev_t *dev)
 	if (!(master = ni_netdev_ref_bind_ifname(&dev->link.masterdev, nc))) {
 		ni_info("Interface %s references unknown master device (ifindex %u)",
 				dev->name, dev->link.masterdev.index);
-		return;
-	}
-
-	if (master->link.type != dev->link.slave.type)
-		return;
-
-	switch (dev->link.slave.type) {
-	case NI_IFTYPE_BOND:
-		__ni_refresh_bonding_master_bind(master, &dev->link, dev->name);
-		break;
-
-	default:
-		break;
 	}
 }
 
@@ -467,39 +444,6 @@ __ni_refresh_bind_lower(ni_netconfig_t *nc, ni_netdev_t *dev)
 	}
 }
 
-static inline void
-__ni_refresh_bonding_master_unbind(ni_netdev_t *master, ni_linkinfo_t *link, const char *ifname)
-{
-	const ni_netdev_ref_t ref = { .name = (char *)ifname, .index = link->ifindex };
-
-	ni_bonding_unbind_slave(master->bonding, &ref, master->name);
-}
-
-static void
-__ni_refresh_unbind_master(ni_netconfig_t *nc, ni_netdev_t *dev)
-{
-	ni_netdev_t *master;
-
-	if (!dev->link.masterdev.index)
-		return;
-
-	if (!(master = ni_netdev_by_index(nc, dev->link.masterdev.index)))
-		return;
-
-	if (master->link.type != dev->link.slave.type)
-		return;
-
-	switch (dev->link.slave.type) {
-	case NI_IFTYPE_BOND:
-		__ni_refresh_bonding_master_unbind(master, &dev->link, dev->name);
-		break;
-
-	default:
-		break;
-	}
-}
-
-
 /*
  * Refresh all interfaces
  */
@@ -633,7 +577,6 @@ __ni_system_refresh_all(ni_netconfig_t *nc, ni_netdev_t **del_list)
 		if (dev->seq != seqno) {
 			*tail = dev->next;
 			if (del_list == NULL) {
-				__ni_refresh_unbind_master(nc, dev);
 				ni_client_state_drop(dev->link.ifindex);
 				ni_netdev_put(dev);
 			} else {
@@ -1126,7 +1069,7 @@ __ni_process_ifinfomsg_linktype(ni_linkinfo_t *link, const char *ifname, ni_netc
 	const char *base;
 
 	/* Try to get linktype from kind string. */
-	if (!__ni_linkinfo_kind_to_type(link->kind, &tmp_link_type))
+	if (!ni_linkinfo_kind_to_type(link->kind, &tmp_link_type))
 		ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_IFCONFIG,
 				"%s: unknown link-info kind: %s", ifname, link->kind);
 
@@ -1255,36 +1198,17 @@ static inline void
 __ni_process_ifinfomsg_masterdev_unbind(ni_linkinfo_t *link, const char *ifname,
 					unsigned int oindex, ni_netconfig_t *nc)
 {
-	const ni_netdev_ref_t ref = { .name = (char *)ifname, .index = link->ifindex };
-	ni_netdev_t *master;
-
-	if ((master = ni_netdev_by_index(nc, oindex))) {
-		switch (master->link.type) {
-		case NI_IFTYPE_BOND:
-			ni_bonding_unbind_slave(master->bonding, &ref, master->name);
-			break;
-		default:
-			break;
-		}
-	}
 	ni_netdev_ref_destroy(&link->masterdev);
+	ni_netdev_port_info_destroy(&link->port);
 }
 
 static inline ni_netdev_t *
 __ni_process_ifinfomsg_masterdev_bind(ni_linkinfo_t *link, const char *ifname,
 				unsigned int mindex, ni_netconfig_t *nc)
 {
-	const ni_netdev_ref_t ref = { .name = (char *)ifname, .index = link->ifindex };
 	ni_netdev_t *master;
 
 	if ((master = ni_netdev_by_index(nc, mindex))) {
-		switch (master->link.type) {
-		case NI_IFTYPE_BOND:
-			ni_bonding_bind_slave(master->bonding, &ref, master->name);
-			break;
-		default:
-			break;
-		}
 		ni_netdev_ref_set(&link->masterdev, master->name, mindex);
 	} else {
 		ni_debug_verbose(NI_LOG_DEBUG, NI_TRACE_EVENTS,
@@ -1320,9 +1244,10 @@ __ni_process_ifinfomsg_masterdev(ni_linkinfo_t *link, const char *ifname,
 }
 
 static inline void
-__ni_process_ifinfomsg_bond_slave_data(ni_linkinfo_t *link, const char *ifname, struct nlattr *data)
+ni_rtnl_link_get_bond_port_info(const char *ifname, ni_linkinfo_t *link,
+		struct nlattr *data)
 {
-	/* static const */ struct nla_policy	__slave_policy[IFLA_BOND_SLAVE_MAX+1] = {
+	/* static const */ struct nla_policy	policy[IFLA_BOND_SLAVE_MAX+1] = {
 		[IFLA_BOND_SLAVE_STATE]			= { .type = NLA_U8      },
 		[IFLA_BOND_SLAVE_MII_STATUS]		= { .type = NLA_U8      },
 		[IFLA_BOND_SLAVE_LINK_FAILURE_COUNT]	= { .type = NLA_U32     },
@@ -1331,7 +1256,7 @@ __ni_process_ifinfomsg_bond_slave_data(ni_linkinfo_t *link, const char *ifname,
 		[IFLA_BOND_SLAVE_AD_AGGREGATOR_ID]	= { .type = NLA_U16     },
 	};
 #define map_attr(attr)  [attr] = #attr
-	static const char *			__slave_attrs[IFLA_BOND_SLAVE_MAX+1] = {
+	static const char *			attrs[IFLA_BOND_SLAVE_MAX+1] = {
 		map_attr(IFLA_BOND_SLAVE_STATE),
 		map_attr(IFLA_BOND_SLAVE_MII_STATUS),
 		map_attr(IFLA_BOND_SLAVE_LINK_FAILURE_COUNT),
@@ -1341,34 +1266,37 @@ __ni_process_ifinfomsg_bond_slave_data(ni_linkinfo_t *link, const char *ifname,
 	};
 #undef  map_attr
 	struct nlattr *tb[IFLA_BOND_SLAVE_MAX+1], *aptr;
-	ni_bonding_slave_info_t *info;
+	ni_bonding_port_info_t *info;
 	unsigned int attr, alen;
 	const char *mapped;
 	const char *name;
 
+	if (!ifname || !link || !link->port.bond || !data)
+		return;
+
 	memset(tb, 0, sizeof(tb));
-	if (nla_parse_nested(tb, IFLA_BOND_SLAVE_MAX, data, __slave_policy) < 0) {
+	if (nla_parse_nested(tb, IFLA_BOND_SLAVE_MAX, data, policy) < 0) {
 		ni_warn("%s: unable to parse bond slave data", ifname);
 		return;
 	}
 
-	info = link->slave.bond;
+	info = link->port.bond;
 	for (attr = IFLA_BOND_SLAVE_STATE; attr <= IFLA_BOND_SLAVE_MAX; ++attr) {
 		if (!(aptr = tb[attr]))
 			continue;
 
-		name = __slave_attrs[attr];
+		name = attrs[attr];
 		switch (attr) {
 		case IFLA_BOND_SLAVE_STATE:
 			info->state = nla_get_u8(aptr);
-			mapped = ni_bonding_slave_state_name(info->state);
+			mapped = ni_bonding_port_state_name(info->state);
 			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
 						"%s: get attr %s=%u (%s)", ifname, name,
 						info->state, mapped);
 			break;
 		case IFLA_BOND_SLAVE_MII_STATUS:
 			info->mii_status = nla_get_u8(aptr);
-			mapped = ni_bonding_slave_mii_status_name(info->mii_status);
+			mapped = ni_bonding_port_mii_status_name(info->mii_status);
 			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
 						"%s: get attr %s=%u (%s)", ifname, name,
 						info->mii_status, mapped);
@@ -1412,43 +1340,193 @@ __ni_process_ifinfomsg_bond_slave_data(ni_linkinfo_t *link, const char *ifname,
 }
 
 static inline void
-__ni_process_ifinfomsg_slave_data(ni_linkinfo_t *link, const char *ifname,
-		ni_netdev_t *master, const char *kind, struct nlattr *data)
+ni_rtnl_link_get_bridge_port_info(const char *ifname, ni_linkinfo_t *link,
+		struct nlattr *data)
+{
+	/* static const */ struct nla_policy	policy[IFLA_BRPORT_MAX+1] = {
+		/*
+		 * the constants are in the linux/if_link.h enum order, for
+		 * types see kernel br_port_info_size() + br_port_fill_attrs()
+		 */
+		[IFLA_BRPORT_STATE]			= { .type = NLA_U8	},
+		[IFLA_BRPORT_PRIORITY]			= { .type = NLA_U16	},
+		[IFLA_BRPORT_COST]			= { .type = NLA_U32	},
+		[IFLA_BRPORT_ID]			= { .type = NLA_U16	},
+		[IFLA_BRPORT_NO]			= { .type = NLA_U16	},
+	};
+#define map_attr(attr)[attr] = #attr
+	static const char *			attrs[IFLA_BRPORT_MAX+1] = {
+		map_attr(IFLA_BRPORT_STATE),
+		map_attr(IFLA_BRPORT_PRIORITY),
+		map_attr(IFLA_BRPORT_COST),
+		map_attr(IFLA_BRPORT_ID),
+		map_attr(IFLA_BRPORT_NO),
+	};
+#undef  map_attr
+	struct nlattr *tb[IFLA_BRPORT_MAX+1], *aptr;
+	ni_bridge_port_info_t *info;
+	unsigned int attr;
+	const char *name;
+
+	if (!ifname || !link || !link->port.bridge || !data)
+		return;
+
+	memset(tb, 0, sizeof(tb));
+	if (nla_parse_nested(tb, IFLA_BRPORT_MAX, data, policy) < 0) {
+		ni_warn("%s: unable to parse netlink bridge port info data",
+				ifname);
+		return;
+	}
+
+	info = link->port.bridge;
+	for (attr = IFLA_BRPORT_STATE; attr <= IFLA_BRPORT_MAX; ++attr) {
+		if (!(aptr = tb[attr]))
+			continue;
+
+		name = attrs[attr];
+		switch (attr) {
+		case IFLA_BRPORT_STATE:
+			info->state = nla_get_u8(aptr);
+			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
+					"%s: get attr %s=%u", ifname, name,
+					info->state);
+			break;
+
+		case IFLA_BRPORT_PRIORITY:
+			info->priority = nla_get_u32(aptr);
+			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
+					"%s: get attr %s=%u", ifname, name,
+					info->priority);
+			break;
+
+		case IFLA_BRPORT_COST:
+			info->path_cost = nla_get_u32(aptr);
+			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
+					"%s: get attr %s=%u", ifname, name,
+					info->path_cost);
+			break;
+
+		case IFLA_BRPORT_ID:
+			info->port_id = nla_get_u16(aptr);
+			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
+					"%s: get attr %s=%u", ifname, name,
+					info->port_id);
+			break;
+
+		case IFLA_BRPORT_NO:
+			info->port_no = nla_get_u16(aptr);
+			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
+					"%s: get attr %s=%u", ifname, name,
+					info->port_no);
+			break;
+
+		default:
+			break;
+		}
+	}
+}
+
+static inline void
+ni_rtnl_link_get_port_info(const char *ifname, ni_linkinfo_t *link,
+		const char *kind, struct nlattr *data,
+		ni_netdev_t *master, ni_netconfig_t *nc)
 {
-	ni_netdev_slaveinfo_destroy(&link->slave);
+	ni_iftype_t type;
+
+	if (!ni_string_eq(link->port.kind, kind)) {
+		ni_netdev_port_info_destroy(&link->port);
+		ni_netdev_port_info_init(&link->port, kind);
+	}
 
-	ni_string_dup(&link->slave.kind, kind);
-	if (!__ni_linkinfo_kind_to_type(kind, &link->slave.type))
-		link->slave.type = NI_IFTYPE_UNKNOWN;
+	if (!ni_linkinfo_kind_to_type(kind, &type))
+		type = NI_IFTYPE_UNKNOWN;
 
-	switch (link->slave.type) {
+	switch (type) {
 	case NI_IFTYPE_BOND:
-		if (master && master->link.type != link->slave.type) {
-			ni_warn("%s: master %s link type does not match slaveinfo kind type",
-					master->name, ifname);
+		if (master && master->link.type != type) {
+			ni_warn("%s: %s port info type does not match %s link type %s",
+					ifname, ni_linktype_type_to_name(type),
+					master->name,
+					ni_linktype_type_to_name(master->link.type));
 			return;
 		}
-
 		if (!data) {
+			ni_debug_verbose(NI_LOG_DEBUG, NI_TRACE_EVENTS,
+					"%s: %s port info type without any data",
+					ifname, ni_linktype_type_to_name(type));
+			return;
+		}
+
+		ni_netdev_port_info_data_destroy(&link->port);
+		if (!ni_netdev_port_info_data_init(&link->port, type)) {
+			ni_warn("%s: unable to initialize/allocate %s port info",
+					ifname, ni_linktype_type_to_name(type));
+			return;
+		}
+		ni_rtnl_link_get_bond_port_info(ifname, link, data);
+		break;
+
+	case NI_IFTYPE_TEAM:
+		if (ni_netconfig_discover_filtered(nc, NI_NETCONFIG_DISCOVER_LINK_EXTERN)) {
 			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
-					"%s: slave info does not provide any data", ifname);
+					"%s: omitting external %s port info discovery",
+					ifname, ni_linktype_type_to_name(type));
 			return;
 		}
 
-		if (master) {
-			ni_bonding_slave_t *slave;
+		ni_netdev_port_info_data_destroy(&link->port);
+		if (!ni_netdev_port_info_data_init(&link->port, type)) {
+			ni_warn("%s: unable to initialize/allocate %s port info",
+					ifname, ni_linktype_type_to_name(type));
+			return;
+		}
+		ni_teamd_port_info_discover(&link->port, link->masterdev.name, ifname);
+		break;
 
-			slave = ni_bonding_slave_array_get_by_ifindex(&master->bonding->slaves,	link->ifindex);
-			link->slave.bond = ni_bonding_slave_info_ref(ni_bonding_slave_get_info(slave));
-		} else {
-			link->slave.bond = ni_bonding_slave_info_new();
+	case NI_IFTYPE_BRIDGE:
+		if (master && master->link.type != type) {
+			ni_warn("%s: %s port info type does not match %s link type %s",
+					ifname, ni_linktype_type_to_name(type),
+					master->name,
+					ni_linktype_type_to_name(master->link.type));
+			return;
+		}
+		if (!data) {
+			ni_debug_verbose(NI_LOG_DEBUG, NI_TRACE_EVENTS,
+					"%s: %s port info type without any data",
+					ifname, ni_linktype_type_to_name(type));
+			return;
 		}
 
-		if (link->slave.bond)
-			__ni_process_ifinfomsg_bond_slave_data(link, ifname, data);
+		ni_netdev_port_info_data_destroy(&link->port);
+		if (!ni_netdev_port_info_data_init(&link->port, type)) {
+			ni_warn("%s: unable to initialize/allocate %s port info",
+					ifname, ni_linktype_type_to_name(type));
+			return;
+		}
+		ni_rtnl_link_get_bridge_port_info(ifname, link, data);
+		break;
+
+	case NI_IFTYPE_OVS_UNSPEC:
+		if (ni_netconfig_discover_filtered(nc, NI_NETCONFIG_DISCOVER_LINK_EXTERN)) {
+			ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
+					"%s: omitting external %s port info discovery",
+					ifname, ni_linktype_type_to_name(type));
+			return;
+		}
+
+		ni_ovs_port_info_discover(&link->port, ifname, nc);
 		break;
 
 	default:
+		/*
+		 * actually unused / unhandled port info kind:
+		 * destroy old data if any and track kind only.
+		 */
+		ni_debug_verbose(NI_LOG_DEBUG2, NI_TRACE_EVENTS,
+				"%s: received %s port info kind %s data",
+				ifname, kind, data ? "with" : "without");
+		ni_netdev_port_info_data_destroy(&link->port);
 		break;
 	}
 }
@@ -1504,6 +1582,14 @@ __ni_process_ifinfomsg_linkinfo(ni_linkinfo_t *link, const char *ifname,
 	if (tb[IFLA_QDISC])
 		ni_string_dup(&link->qdisc, nla_get_string(tb[IFLA_QDISC]));
 
+	if (tb[IFLA_OPERSTATE]) {
+		/* get the RFC 2863 operational status - IF_OPER_* */
+		link->oper_state = nla_get_u8(tb[IFLA_OPERSTATE]);
+	}
+
+	if (tb[IFLA_IFALIAS])
+		ni_string_dup(&link->alias, nla_get_string(tb[IFLA_IFALIAS]));
+
 	if (tb[IFLA_LINK]) {
 		link->lowerdev.index = nla_get_u32(tb[IFLA_LINK]);
 		if (!ni_netdev_ref_bind_ifname(&link->lowerdev, nc)) {
@@ -1523,47 +1609,6 @@ __ni_process_ifinfomsg_linkinfo(ni_linkinfo_t *link, const char *ifname,
 		master = NULL;
 	}
 
-	if (tb[IFLA_IFALIAS])
-		ni_string_dup(&link->alias, nla_get_string(tb[IFLA_IFALIAS]));
-	if (tb[IFLA_OPERSTATE]) {
-		/* get the RFC 2863 operational status - IF_OPER_* */
-		link->oper_state = nla_get_u8(tb[IFLA_OPERSTATE]);
-	}
-
-	if (tb[IFLA_STATS]) {
-		struct rtnl_link_stats *s = nla_data(tb[IFLA_STATS]);
-		ni_link_stats_t *n;
-
-		if (!link->stats)
-			link->stats = calloc(1, sizeof(*n));
-
-		if ((n = link->stats)) {
-			n->rx_packets = s->rx_packets;
-			n->tx_packets = s->tx_packets;
-			n->rx_bytes = s->rx_bytes;
-			n->tx_bytes = s->tx_bytes;
-			n->rx_errors = s->rx_errors;
-			n->tx_errors = s->tx_errors;
-			n->rx_dropped = s->rx_dropped;
-			n->tx_dropped = s->tx_dropped;
-			n->multicast = s->multicast;
-			n->collisions = s->collisions;
-			n->rx_length_errors = s->rx_length_errors;
-			n->rx_over_errors = s->rx_over_errors;
-			n->rx_crc_errors = s->rx_crc_errors;
-			n->rx_frame_errors = s->rx_frame_errors;
-			n->rx_fifo_errors = s->rx_fifo_errors;
-			n->rx_missed_errors = s->rx_missed_errors;
-			n->tx_aborted_errors = s->tx_aborted_errors;
-			n->tx_carrier_errors = s->tx_carrier_errors;
-			n->tx_fifo_errors = s->tx_fifo_errors;
-			n->tx_heartbeat_errors = s->tx_heartbeat_errors;
-			n->tx_window_errors = s->tx_window_errors;
-			n->rx_compressed = s->rx_compressed;
-			n->tx_compressed = s->tx_compressed;
-		}
-	}
-
 	/* Extended link info. Let's use it to try to determine link->type.
 	 *
 	 * IFLA_LINKINFO is a nested set of attrs. It always contains
@@ -1603,9 +1648,9 @@ __ni_process_ifinfomsg_linkinfo(ni_linkinfo_t *link, const char *ifname,
 		}
 
 		if (nl_linkinfo[IFLA_INFO_SLAVE_KIND]) {
-			__ni_process_ifinfomsg_slave_data(link, ifname, master,
+			ni_rtnl_link_get_port_info(ifname, link,
 					nla_get_string(nl_linkinfo[IFLA_INFO_SLAVE_KIND]),
-					nl_linkinfo[IFLA_INFO_SLAVE_DATA]);
+					nl_linkinfo[IFLA_INFO_SLAVE_DATA], master, nc);
 		}
 	}
 
@@ -3486,8 +3531,6 @@ static int
 __ni_discover_bridge(ni_netdev_t *dev)
 {
 	ni_bridge_t *bridge;
-	ni_string_array_t ports;
-	unsigned int i;
 
 	if (dev->link.type != NI_IFTYPE_BRIDGE)
 		return 0;
@@ -3497,28 +3540,6 @@ __ni_discover_bridge(ni_netdev_t *dev)
 	ni_sysfs_bridge_get_config(dev->name, bridge);
 	ni_sysfs_bridge_get_status(dev->name, &bridge->status);
 
-	ni_string_array_init(&ports);
-	ni_sysfs_bridge_get_port_names(dev->name, &ports);
-	ni_bridge_ports_destroy(bridge);
-
-	for (i = 0; i < ports.count; ++i) {
-		const char *ifname = ports.data[i];
-		unsigned int index;
-		ni_bridge_port_t *port;
-
-		if ((index = ni_netdev_name_to_index(ifname)) == 0) {
-			/* Looks like someone is renaming interfaces while we're
-			 * trying to discover them :-( */
-			ni_error("%s: port interface %s has index 0?!", __func__, ifname);
-			continue;
-		}
-		port = ni_bridge_port_new(bridge, ifname, index);
-
-		ni_sysfs_bridge_port_get_config(port->ifname, port);
-		ni_sysfs_bridge_port_get_status(port->ifname, &port->status);
-	}
-	ni_string_array_destroy(&ports);
-
 	return 0;
 }
 
diff --git a/src/names.c b/src/names.c
index 15881d0e9..9f3790e4d 100644
--- a/src/names.c
+++ b/src/names.c
@@ -51,7 +51,7 @@ ni_tristate_by_name(const char *name, ni_tristate_t *tristate)
 /*
  * Map interface link layer types to strings and vice versa
  */
-static const ni_intmap_t	__linktype_names[] = {
+static const ni_intmap_t	ni_linktype_name_map[] = {
 	{ "unknown",		NI_IFTYPE_UNKNOWN },
 	{ "loopback",		NI_IFTYPE_LOOPBACK },
 	{ "ethernet",		NI_IFTYPE_ETHERNET },
@@ -89,7 +89,7 @@ ni_linktype_name_to_type(const char *name)
 {
 	unsigned int value;
 
-	if (ni_parse_uint_mapped(name, __linktype_names, &value) < 0)
+	if (ni_parse_uint_mapped(name, ni_linktype_name_map, &value) < 0)
 		return -1;
 	return value;
 }
@@ -97,15 +97,17 @@ ni_linktype_name_to_type(const char *name)
 const char *
 ni_linktype_type_to_name(unsigned int type)
 {
-	return ni_format_uint_mapped(type, __linktype_names);
+	return ni_format_uint_mapped(type, ni_linktype_name_map);
 }
 
 /*
- * Map kernel kind to type
+ * Map kernel kind to wicked iftype
  *
- * Note: this is an initial, incomplete, one-direction match!
+ * Note: the kind string is what the kernel is using,
+ *       but it's not yet / 1:1 the final wicked type,
+ *       see e.g. tun & tap or ovs kind and types.
  */
-static const ni_intmap_t	__linkinfo_kind_names[] = {
+static const ni_intmap_t	ni_linkinfo_kind_map[] = {
 	{ "bridge",		NI_IFTYPE_BRIDGE },
 	{ "bond",		NI_IFTYPE_BOND },
 	{ "team",		NI_IFTYPE_TEAM },
@@ -120,20 +122,27 @@ static const ni_intmap_t	__linkinfo_kind_names[] = {
 	{ "gre",		NI_IFTYPE_GRE },
 	{ "openvswitch",	NI_IFTYPE_OVS_UNSPEC }, /* new in 4.4 kernels */
 
-	{ NULL }
+	{ NULL,			NI_IFTYPE_UNKNOWN }
 };
 
 ni_bool_t
-__ni_linkinfo_kind_to_type(const char *name, ni_iftype_t *iftype)
+ni_linkinfo_kind_to_type(const char *kind, ni_iftype_t *type)
 {
 	unsigned int value;
 
-	if (!iftype || ni_parse_uint_mapped(name, __linkinfo_kind_names, &value) < 0)
+	if (!type || ni_parse_uint_mapped(kind, ni_linkinfo_kind_map, &value) < 0)
 		return FALSE;
-	*iftype = value;
+
+	*type = value;
 	return TRUE;
 }
 
+const char *
+ni_linkinfo_type_to_kind(ni_iftype_t type)
+{
+	return ni_format_uint_mapped(type, ni_linkinfo_kind_map);
+}
+
 /*
  * Map addrconf name to type constant and vice versa
  */
diff --git a/src/netdev.c b/src/netdev.c
index d51104986..6d117c964 100644
--- a/src/netdev.c
+++ b/src/netdev.c
@@ -80,18 +80,88 @@ ni_netdev_clear_routes(ni_netdev_t *dev)
 	ni_route_tables_destroy(&dev->routes);
 }
 
+ni_bool_t
+ni_netdev_port_info_data_init(ni_netdev_port_info_t *info, ni_iftype_t type)
+{
+	if (info) {
+		switch (type) {
+		case NI_IFTYPE_BOND:
+			if (!(info->bond = ni_bonding_port_info_new()))
+				return FALSE;
+			break;
+
+		case NI_IFTYPE_TEAM:
+			if (!(info->team = ni_team_port_info_new()))
+				return FALSE;
+			break;
+
+		case NI_IFTYPE_BRIDGE:
+			if (!(info->bridge = ni_bridge_port_info_new()))
+				return FALSE;
+			break;
+
+		case NI_IFTYPE_OVS_BRIDGE:
+			if (!(info->ovsbr = ni_ovs_bridge_port_info_new()))
+				return FALSE;
+			break;
+
+		default:
+			info->bond = NULL; /* union ptr */
+			break;
+		}
+
+		info->type = type;
+		return TRUE;
+	}
+	return FALSE;
+}
+
 void
-ni_netdev_slaveinfo_destroy(ni_slaveinfo_t *slave)
+ni_netdev_port_info_data_destroy(ni_netdev_port_info_t *info)
 {
-	switch (slave->type) {
-	case NI_IFTYPE_BOND:
-		ni_bonding_slave_info_free(slave->bond);
-		break;
-	default:
-		break;
+	if (info) {
+		switch (info->type) {
+		case NI_IFTYPE_BOND:
+			ni_bonding_port_info_free(info->bond);
+			break;
+
+		case NI_IFTYPE_TEAM:
+			ni_team_port_info_free(info->team);
+			break;
+
+		case NI_IFTYPE_BRIDGE:
+			ni_bridge_port_info_free(info->bridge);
+			break;
+
+		case NI_IFTYPE_OVS_BRIDGE:
+			ni_ovs_bridge_port_info_free(info->ovsbr);
+			break;
+
+		default:
+			break;
+		}
+		info->bond = NULL; /* union ptr */
+		info->type = NI_IFTYPE_UNKNOWN;
+	}
+}
+
+ni_bool_t
+ni_netdev_port_info_init(ni_netdev_port_info_t *info, const char *kind)
+{
+	if (info) {
+		ni_netdev_port_info_data_init(info, NI_IFTYPE_UNKNOWN);
+		return ni_string_dup(&info->kind, kind);
+	}
+	return FALSE;
+}
+
+void
+ni_netdev_port_info_destroy(ni_netdev_port_info_t *info)
+{
+	if (info) {
+		ni_netdev_port_info_data_destroy(info);
+		ni_string_free(&info->kind);
 	}
-	free(slave->kind);
-	memset(slave, 0, sizeof(*slave));
 }
 
 void
@@ -118,12 +188,11 @@ ni_netdev_reset(ni_netdev_t *dev)
 
 	ni_netdev_ref_destroy(&dev->link.lowerdev);
 	ni_netdev_ref_destroy(&dev->link.masterdev);
-	ni_netdev_slaveinfo_destroy(&dev->link.slave);
+	ni_netdev_port_info_destroy(&dev->link.port);
 
 	ni_string_free(&dev->link.qdisc);
 	ni_string_free(&dev->link.kind);
 
-	ni_netdev_set_link_stats(dev, NULL);
 	ni_netdev_set_client_state(dev, NULL);
 
 	ni_netdev_clear_addresses(dev);
@@ -215,29 +284,6 @@ ni_netdev_device_is_ready(ni_netdev_t *dev)
 	return dev ? dev->link.ifflags & NI_IFF_DEVICE_READY : FALSE;
 }
 
-ni_tristate_t
-ni_netdev_guess_link_required(const ni_netdev_t *dev)
-{
-	ni_tristate_t link_required = NI_TRISTATE_DEFAULT;
-
-	switch (dev->link.type) {
-	case NI_IFTYPE_OVS_SYSTEM:
-	case NI_IFTYPE_TUN:
-	case NI_IFTYPE_TAP:
-		ni_tristate_set(&link_required, FALSE);
-		break;
-
-	case NI_IFTYPE_BRIDGE:
-		if (dev->bridge && dev->bridge->stp && !dev->bridge->ports.count)
-			ni_tristate_set(&link_required, FALSE);
-		break;
-
-	default:
-		break;
-	}
-	return link_required;
-}
-
 /*
  * Get the interface's VLAN information
  */
@@ -599,17 +645,6 @@ ni_netdev_set_dcb(ni_netdev_t *dev, ni_dcb_t *dcb)
 	dev->dcb = dcb;
 }
 
-/*
- * Set the interface's link stats
- */
-void
-ni_netdev_set_link_stats(ni_netdev_t *dev, ni_link_stats_t *stats)
-{
-	if (dev->link.stats)
-		free(dev->link.stats);
-	dev->link.stats = stats;
-}
-
 /*
  * Set the PCI device info
  */
diff --git a/src/netinfo.c b/src/netinfo.c
index c01e80d30..28617b858 100644
--- a/src/netinfo.c
+++ b/src/netinfo.c
@@ -72,7 +72,7 @@ static int
 __ni_init_gcrypt(void)
 {
 /*
- * gcry_check_version checks for minmum version
+ * gcry_check_version checks for minimum version
  * we want consider sufficient and returns NULL
  * on failures.
  *
@@ -580,13 +580,15 @@ ni_netconfig_device_append(ni_netconfig_t *nc, ni_netdev_t *dev)
 }
 
 static inline void
-ni_netconfig_device_unbind_slave_index(ni_netconfig_t *nc, unsigned int master)
+ni_netconfig_device_unbind_ports(ni_netconfig_t *nc, unsigned int master)
 {
 	ni_netdev_t *dev;
 
 	for (dev = nc->interfaces; dev; dev = dev->next) {
-		if (dev->link.masterdev.index == master)
+		if (dev->link.masterdev.index == master) {
 			ni_netdev_ref_destroy(&dev->link.masterdev);
+			ni_netdev_port_info_destroy(&dev->link.port);
+		}
 	}
 }
 
@@ -598,7 +600,7 @@ ni_netconfig_device_remove(ni_netconfig_t *nc, ni_netdev_t *dev)
 	for (pos = &nc->interfaces; (cur = *pos) != NULL; pos = &cur->next) {
 		if (cur == dev) {
 			*pos = cur->next;
-			ni_netconfig_device_unbind_slave_index(nc, cur->link.ifindex);
+			ni_netconfig_device_unbind_ports(nc, cur->link.ifindex);
 			ni_netdev_put(cur);
 			return;
 		}
@@ -814,6 +816,9 @@ ni_netdev_by_name(ni_netconfig_t *nc, const char *name)
 {
 	ni_netdev_t *dev;
 
+	if (!nc && !(nc = ni_global_state_handle(0)))
+		return NULL;
+
 	for (dev = nc->interfaces; dev; dev = dev->next) {
 		if (dev->name && ni_string_eq(dev->name, name))
 			return dev;
@@ -830,6 +835,9 @@ ni_netdev_by_index(ni_netconfig_t *nc, unsigned int ifindex)
 {
 	ni_netdev_t *dev;
 
+	if (!nc && !(nc = ni_global_state_handle(0)))
+		return NULL;
+
 	for (dev = nc->interfaces; dev; dev = dev->next) {
 		if (dev->link.ifindex == ifindex)
 			return dev;
@@ -849,6 +857,9 @@ ni_netdev_by_hwaddr(ni_netconfig_t *nc, const ni_hwaddr_t *lla)
 	if (!lla || !lla->len)
 		return NULL;
 
+	if (!nc && !(nc = ni_global_state_handle(0)))
+		return NULL;
+
 	for (dev = nc->interfaces; dev; dev = dev->next) {
 		if (ni_link_address_equal(&dev->link.hwaddr, lla))
 			return dev;
@@ -857,6 +868,25 @@ ni_netdev_by_hwaddr(ni_netconfig_t *nc, const ni_hwaddr_t *lla)
 	return NULL;
 }
 
+/*
+ * Find network interface by iftype
+ */
+ni_netdev_t *
+ni_netdev_by_iftype(ni_netconfig_t *nc, ni_iftype_t iftype)
+{
+	ni_netdev_t *dev;
+
+	if (!nc && !(nc = ni_global_state_handle(0)))
+		return NULL;
+
+	for (dev = nc->interfaces; dev; dev = dev->next) {
+		if (dev->link.type == iftype)
+			return dev;
+	}
+
+	return NULL;
+}
+
 /*
  * Find VLAN interface by its tag
  */
@@ -867,6 +897,10 @@ ni_netdev_by_vlan_name_and_tag(ni_netconfig_t *nc, const char *parent_name, uint
 
 	if (!parent_name || !tag)
 		return NULL;
+
+	if (!nc && !(nc = ni_global_state_handle(0)))
+		return NULL;
+
 	for (dev = nc->interfaces; dev; dev = dev->next) {
 		if (dev->link.type == NI_IFTYPE_VLAN
 		 && dev->vlan
@@ -923,6 +957,113 @@ ni_netdev_make_name(ni_netconfig_t *nc, const char *stem, unsigned int first)
 	return NULL;
 }
 
+/*
+ * Get port count and optionally an array of port netdev
+ * references for the given netdev (index).
+ */
+static unsigned int
+ni_netdev_get_ovsbr_ports_by_index(unsigned int index, ni_netdev_ref_array_t *ports,
+		ni_netconfig_t *nc)
+{
+	unsigned int count = ports ? ports->count : 0;
+	ni_ovs_bridge_port_info_t *pinfo;
+	ni_netdev_t *dev;
+
+	if (!index || (!nc && !(nc = ni_global_state_handle(0))))
+		return count;
+
+	for (dev = nc->interfaces; dev; dev = dev->next) {
+		if (dev->link.port.type != NI_IFTYPE_OVS_BRIDGE)
+			continue;
+
+		if (!(pinfo = dev->link.port.ovsbr))
+			continue;
+
+		if (index != pinfo->bridge.index)
+			continue;
+
+		if (ports)
+			ni_netdev_ref_array_append(ports, dev->name,
+					dev->link.ifindex);
+		else
+			count++;
+	}
+
+	return ports ? ports->count - count : count;
+}
+
+static unsigned int
+ni_netdev_get_ports_by_index(unsigned int index, ni_netdev_ref_array_t *ports,
+		ni_netconfig_t *nc)
+{
+	unsigned int count = ports ? ports->count : 0;
+	ni_netdev_t *dev;
+
+	if (!index || (!nc && !(nc = ni_global_state_handle(0))))
+		return count;
+
+	for (dev = nc->interfaces; dev; dev = dev->next) {
+		if (dev->link.masterdev.index != index)
+			continue;
+
+		if (ports)
+			ni_netdev_ref_array_append(ports, dev->name,
+					dev->link.ifindex);
+		else
+			count++;
+	}
+
+	return ports ? ports->count - count : count;
+}
+
+extern unsigned int
+ni_netdev_get_ports(const ni_netdev_t *dev, ni_netdev_ref_array_t *ports,
+		ni_netconfig_t *nc)
+{
+	unsigned int index;
+
+	if (!dev)
+		return ports ? ports->count : 0;
+
+	index = dev->link.ifindex;
+	if (dev->link.type == NI_IFTYPE_OVS_BRIDGE)
+		return ni_netdev_get_ovsbr_ports_by_index(index, ports, nc);
+	else
+		return ni_netdev_get_ports_by_index(index, ports, nc);
+}
+
+/*
+ * Resolve port's master reference to netdev
+ */
+const ni_netdev_ref_t *
+ni_netdev_get_master_ref(const ni_netdev_t *dev)
+{
+	if (!dev)
+		return NULL;
+
+	if (dev->link.port.type == NI_IFTYPE_OVS_BRIDGE) {
+		ni_ovs_bridge_port_info_t *ovsbr;
+
+		if (!(ovsbr = dev->link.port.ovsbr))
+			return NULL;
+
+		return &ovsbr->bridge;
+	}
+
+	return &dev->link.masterdev;
+}
+
+ni_netdev_t *
+ni_netdev_resolve_master(const ni_netdev_t *dev, ni_netconfig_t *nc)
+{
+	const ni_netdev_ref_t *ref;
+
+	if ((ref = ni_netdev_get_master_ref(dev)))
+		return ni_netdev_ref_resolve(ref, nc);
+
+	return NULL;
+}
+
 /*
  * netdev reference
  */
@@ -1134,63 +1275,68 @@ ni_netdev_ref_array_destroy(ni_netdev_ref_array_t *array)
 /*
  * Handle netdev request port config
  */
-static void
-ni_netdev_port_req_init(ni_netdev_port_req_t *port)
-{
-	switch (port->type) {
-        case NI_IFTYPE_TEAM:
-		ni_team_port_config_init(&port->team);
-		break;
-
-	case NI_IFTYPE_OVS_BRIDGE:
-		ni_ovs_bridge_port_config_init(&port->ovsbr);
-		break;
-
-	case NI_IFTYPE_BOND:
-	case NI_IFTYPE_BRIDGE:
-	default:
-		break;
-	}
-}
-
-ni_netdev_port_req_t *
-ni_netdev_port_req_new(ni_iftype_t master)
+ni_bool_t
+ni_netdev_port_config_init(ni_netdev_port_config_t *conf, ni_iftype_t type)
 {
-	ni_netdev_port_req_t *port;
+	if (conf) {
+		memset(conf, 0, sizeof(*conf));
 
-	switch (master) {
-	case NI_IFTYPE_TEAM:
-	case NI_IFTYPE_BOND:
-	case NI_IFTYPE_BRIDGE:
-	case NI_IFTYPE_OVS_BRIDGE:
-		port = xcalloc(1, sizeof(*port));
-		port->type = master;
-		ni_netdev_port_req_init(port);
-		return port;
-	default:
-		return NULL;
+		switch (type) {
+		case NI_IFTYPE_BOND:
+			if (!(conf->bond = ni_bonding_port_config_new()))
+				return FALSE;
+			break;
+
+		case NI_IFTYPE_TEAM:
+			if (!(conf->team = ni_team_port_config_new()))
+				return FALSE;
+			break;
+
+		case NI_IFTYPE_BRIDGE:
+			if (!(conf->bridge = ni_bridge_port_config_new()))
+				return FALSE;
+			break;
+
+		case NI_IFTYPE_OVS_BRIDGE:
+			if (!(conf->ovsbr = ni_ovs_bridge_port_config_new()))
+				return FALSE;
+			break;
+
+		default:
+			break;
+		}
+		conf->type = type;
+
+		return TRUE;
 	}
+	return FALSE;
 }
-
 void
-ni_netdev_port_req_free(ni_netdev_port_req_t *port)
+ni_netdev_port_config_destroy(ni_netdev_port_config_t *conf)
 {
-	if (port) {
-		switch (port->type) {
+	if (conf) {
+		switch (conf->type) {
+		case NI_IFTYPE_BOND:
+			ni_bonding_port_config_free(conf->bond);
+			break;
+
 		case NI_IFTYPE_TEAM:
-			ni_team_port_config_destroy(&port->team);
+			ni_team_port_config_free(conf->team);
+			break;
+
+		case NI_IFTYPE_BRIDGE:
+			ni_bridge_port_config_free(conf->bridge);
 			break;
 
 		case NI_IFTYPE_OVS_BRIDGE:
-			ni_ovs_bridge_port_config_destroy(&port->ovsbr);
+			ni_ovs_bridge_port_config_free(conf->ovsbr);
 			break;
 
-		case NI_IFTYPE_BOND:
-		case NI_IFTYPE_BRIDGE:
 		default:
 			break;
 		}
-		free(port);
+
+		memset(conf, 0, sizeof(*conf));
 	}
 }
 
@@ -1211,7 +1357,7 @@ ni_netdev_req_free(ni_netdev_req_t *req)
 {
 	ni_string_free(&req->alias);
 	ni_netdev_ref_destroy(&req->master);
-	ni_netdev_port_req_free(req->port);
+	ni_netdev_port_config_destroy(&req->port);
 	free(req);
 }
 
